use crate::script_implementations::rune::wrappers::impl_rune_wrapper;
use crate::static_data::LibrarySettings;
use std::sync::Arc;

pub fn register(module: &mut rune::Module) -> anyhow::Result<()> {
    module.ty::<RuneLibrarySettings>()?;
    module.function_meta(RuneLibrarySettings::maximum_level)?;
    module.function_meta(RuneLibrarySettings::shiny_rate)?;
    Ok(())
}

#[derive(Debug, rune::Any)]
struct RuneLibrarySettings(Arc<dyn LibrarySettings>);

impl_rune_wrapper!(&Arc<dyn LibrarySettings>, RuneLibrarySettings);

impl RuneLibrarySettings {
    #[rune::function]
    fn maximum_level(&self) -> i64 { self.0.maximum_level() as i64 }

    #[rune::function]
    fn shiny_rate(&self) -> i64 { self.0.shiny_rate() as i64 }
}
