use crate::script_implementations::rune::wrappers::static_data::nature::RuneNature;
use crate::script_implementations::rune::wrappers::{impl_rune_wrapper, RuneStringKey, RuneWrapper};
use crate::static_data::NatureLibrary;
use rune::runtime::Value;
use std::sync::Arc;

pub fn register(module: &mut rune::Module) -> anyhow::Result<()> {
    module.ty::<RuneNatureLibrary>()?;
    module.function_meta(RuneNatureLibrary::get_nature)?;
    module.function_meta(RuneNatureLibrary::get_nature_name)?;
    Ok(())
}

#[derive(Debug, rune::Any)]
struct RuneNatureLibrary(Arc<dyn NatureLibrary>);

impl_rune_wrapper!(&Arc<dyn NatureLibrary>, RuneNatureLibrary);

impl RuneNatureLibrary {
    #[rune::function]
    fn get_nature(&self, key: RuneStringKey) -> Option<Value> { self.0.get_nature(&key.0).map(|v| v.wrap()) }

    #[rune::function]
    fn get_nature_name(&self, nature: &RuneNature) -> RuneStringKey {
        RuneStringKey(self.0.get_nature_name(&nature.0).unwrap())
    }
}
