mod ability;
pub mod form;
mod growth_rate;
pub mod item;
mod learnable_moves;
pub mod libraries;
mod move_data;
mod nature;
mod species;
mod statistic_set;

use crate::static_data::{Gender, Statistic, TimeOfDay};

pub fn register(module: &mut rune::Module) -> anyhow::Result<()> {
    module.ty::<TimeOfDay>()?;
    module.ty::<Statistic>()?;
    module.ty::<Gender>()?;
    statistic_set::register(module)?;
    nature::register(module)?;
    item::register(module)?;
    growth_rate::register(module)?;
    form::register(module)?;
    ability::register(module)?;
    learnable_moves::register(module)?;
    species::register(module)?;
    move_data::register(module)?;

    libraries::register(module)?;
    Ok(())
}
