/// The time of day. These values are the 4 different groups of time of day in Pokemon games since
/// gen 5. The exact times these correspond to differ between games.
#[derive(Debug, Clone, Copy, PartialEq, Eq, Hash)]
#[cfg_attr(feature = "rune", derive(rune::Any))]
#[repr(u8)]
pub enum TimeOfDay {
    /// The morning.
    Morning = 0,
    /// The day.
    Day = 1,
    /// The evening.
    Evening = 2,
    /// The night.
    Night = 3,
}
